*:*********************************************************************
*:
*: Procedure file: C:\FOXPRO\CURRENT\DON-MATY\MAKEFILT.PRG
*:
*:         System: C Systems
*:         Author: Bryan Croft
*:      Copyright (c) 1993, Bryan Croft
*:  Last modified: 02/21/93     11:40
*:
*:  Procs & Fncts: ASTERFIRST
*:               : ONLYQUESTION
*:
*:          Calls: ASTERFIRST         (procedure in MAKEFILT.PRG)
*:               : ONLYQUESTION       (procedure in MAKEFILT.PRG)
*:
*:      Documented 02/21/93 at 11:41               FoxDoc  version 2.10b
*:*********************************************************************
*
* USE DOS wild cards " ? " and " * " in GET field !
*
*
*:*********************************************************************
*                             NOTICE 
*:*********************************************************************
*                    THIS PROGRAM IS NOT FREE !
*
* if this program is used in ANY Company, Corporation 
* or any other for profit application--
* Send  $25 and a SASE to:
*
*             Bryan Croft
*             C Systems
*             400 Dorset 
*             Wilmington IL
*             60481
*
* and I will send a disclaimer and some other neet utilities
* to you.
*
* if you have any comments or suggestions
* drop me EMAIL or call at 1-815-476-2269
*
************************************************************
*                     example
************************************************************
*
*     WildPhrase='Th? gr?en C*W '    && wild card word or phrase
*     FldName='Name'                 && Field to set filter to (maybe get from VARREAD() )
*     T_Case=1                       && make it search on UPPER
*
*  # with the above settings the command -
*
*          FILT=Makefilt(WildPhrase,FldName,1)
*
*  # the return value stores in the variable FILT the following -
*
*   UPPER (SUBSTR(Name,1,2)) = "TH"   AND  ;
*      UPPER (SUBSTR(Name,4,3)) = " GR"   AND  UPPER (SUBSTR(Name,8,4)) = "EN C"
*
*  # which you can the set the filter to like this -
*
*         SET FILTER TO &FILT
*
*  # then Browse or search someway for the match(s) 
*
*  # you could LOCATE or SEEK on this too ! (let me know)
*
************************************************************
* must send the expression with wildcards       > WildPhrase
* must send the FldName to T_Case in            > FldName
*
* optionally send to make filter T_Case for 'UPPER' , 'LOWER', "PROPER' or none
* T_Case > 1='UPPER' 2='LOWER'   missing or any other number=normal
*
************************************************************
*
PARAMETER WildPhrase ,FldName,T_Case
*
PRIVATE Ret_filt_exp,T_Case,New_Case
*
Ret_filt_exp=''
*
IF PARAMETERS()>1
   *make T_Case =0 if not 1,2 or 3
   *
   IF TYPE('T_Case')<>'N'
      T_Case=0
   ELSE
      IF T_Case>2 OR T_Case <1
         T_Case=0
      ENDIF
   ENDIF
   *
   DO CASE
   CASE T_Case=1
      New_Case=' UPPER '
      WildPhrase=UPPER(WildPhrase)
   CASE T_Case=2
      New_Case=' LOWER '
      WildPhrase=LOWER(WildPhrase)
   OTHERWISE
      New_Case=''
   ENDCASE
   * 
   *see if user used wild cards.
   Loc_asterick=AT('*',WildPhrase)          &&first asterick is all that matters
   Loc_question=AT('?',WildPhrase)          &&have to check later for additional questions
   IF Loc_asterick>0 OR Loc_question>0
      *
      *yes user used wild cards so build expresion to T_Case for
      IF Loc_asterick>0 AND Loc_question>0
         * used both so see if asterick is first and disregard question marks
         IF Loc_asterick<Loc_question
            DO Asterfirst
         ELSE
            *
            Loc_asterick=LEN(WildPhrase)
            DO Onlyquestion
         ENDIF
         *
      ELSE
         *
         IF Loc_asterick>0
            *
            *only asterick
            DO Asterfirst
         ELSE
            *
            *
            *only question
            Loc_asterick=LEN(WildPhrase)
            DO Onlyquestion
         ENDIF
         *
      ENDIF
      *
   ENDIF
   *
ENDIF
                                                                            if program()<>'MAKEFILT'
                                                                                ?? CHR(7)
                                                                             activate screen       
                                                                             ? 'DO NOT CHANGE PROGRAM NAME!'
                                                                             cancel       
                                                                             endif
RETURN Ret_filt_exp
*!*********************************************************************
*!
*!      Procedure: ONLYQUESTION
*!
*!      Called by: MAKEFILT.PRG                      
*!
*!*********************************************************************
PROCEDURE Onlyquestion
   *
   *question is first so build
   *
   *see how many question before asterick
   Nq=0
   *
   *dimension parts(1)
   FOR A=1 TO Loc_asterick
      IF SUBSTR(WildPhrase,A,1)='*'         && disregard anything after asterick
         EXIT
      ENDIF
      *
      IF SUBSTR(WildPhrase,A,1)='?'
         Nq=Nq+1
         DIMENSION Parts(Nq,2)
         Parts(Nq,2)=A                      &&remember where questions are
         IF Nq=1
            Parts(Nq,1)=SUBSTR(WildPhrase,1,A-1) && add from beginning
         ELSE
            *
            Parts(Nq,1)=SUBSTR(WildPhrase,Parts(Nq-1,2)+1,A-(Parts(Nq-1,2)+1)) &&add from last question
         ENDIF
         *
      ENDIF
      *
   NEXT
   *
   IF Parts(Nq,2)<A
      Nq=Nq+1
      DIMENSION Parts(Nq+1,2)               && add last chars
      Parts(Nq,1)=SUBSTR(WildPhrase,Parts(Nq-1,2)+1,A-(Parts(Nq-1,2)+1))
      Parts(Nq,2)=A
   ENDIF
   *
   *
   *
   *put the expression together
   FOR A=1 TO  Nq
      IF A>1
         Sp=Parts(A-1,2)+1
         Starstr=ALLTRIM(STR(Sp))
      ELSE
         *
         Sp=1
         Starstr='1'
      ENDIF
      *
      Endstr=ALLTRIM(STR(Parts(A,2)-(Sp)))
      IF VAL(Endstr)>0
         Ret_filt_exp=Ret_filt_exp+IIF(A>1,' AND ','  ')+;
            New_Case+ '(SUBSTR('+FldName+','+Starstr+','+Endstr+'))' +' = '+'"'+Parts(A,1)+'"  '
      ENDIF
   NEXT
*!*********************************************************************
*!
*!      Procedure: ASTERFIRST
*!
*!      Called by: MAKEFILT.PRG                      
*!
*!*********************************************************************
PROCEDURE Asterfirst
   *
   * build expression that only takes into account chars before asterick
   IF Loc_asterick>2                        && if asterick is first then all records are available
      *find where asterick is
      Ret_filt_exp=New_Case+'(LEFT('+FldName+','+ALLTRIM(STR(Loc_asterick-1))+'))="'+LEFT(WildPhrase,Loc_asterick-1)+'"'
   ENDIF
   RETURN

*: EOF: MAKEFILT.PRG
